# Go API client for swagger

REST API Brownbook 

## Overview
This API client was generated by the [swagger-codegen](https://github.com/swagger-api/swagger-codegen) project.  By using the [swagger-spec](https://github.com/swagger-api/swagger-spec) from a remote server, you can easily generate an API client.

- API version: 1.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.go.GoClientCodegen

## Installation
Put the package under your project folder and add the following in import:
```golang
import "./swagger"
```

## Documentation for API Endpoints

All URIs are relative to *https://api.brownbook.net/*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*BusinessApi* | [**ExportBusiness**](docs/BusinessApi.md#exportbusiness) | **Get** /business/export | https://api.brownbook.net/api/v1/business/export
*BusinessesApi* | [**DeleteBusinessReply**](docs/BusinessesApi.md#deletebusinessreply) | **Delete** /businesses/reviews/reply/{replyId} | deleteBusinessReply
*BusinessesApi* | [**GetBusiness**](docs/BusinessesApi.md#getbusiness) | **Get** /businesses/{businessId} | https://api.brownbook.net/businesses/{businessId}
*BusinessesApi* | [**GetBusinessDupe**](docs/BusinessesApi.md#getbusinessdupe) | **Get** /businesses/dupe/{businessId} | https://api.brownbook.net/businesses/dupe/{businessId}
*BusinessesApi* | [**GetBusinesses**](docs/BusinessesApi.md#getbusinesses) | **Get** /businesses | https://api.brownbook.net/businesses/
*BusinessesApi* | [**GetBusinessesReviews**](docs/BusinessesApi.md#getbusinessesreviews) | **Get** /businesses/reviews | https://api.brownbook.net/businesses/reviews/
*BusinessesApi* | [**PostBusinessReply**](docs/BusinessesApi.md#postbusinessreply) | **Put** /businesses/reviews/reply/{commentId} | https://api.brownbook.net/businesses/reviews/{commentId}
*BusinessesApi* | [**PostBusinesses**](docs/BusinessesApi.md#postbusinesses) | **Post** /businesses | https://api.brownbook.net/businesses/
*BusinessesApi* | [**UnclaimBusiness**](docs/BusinessesApi.md#unclaimbusiness) | **Get** /businesses/unclaim/{businessId} | https://api.brownbook.net/businesses/unclaim/{businessId}
*BusinessesApi* | [**UpdateBusinessReply**](docs/BusinessesApi.md#updatebusinessreply) | **Post** /businesses/reviews/reply/{replyId} | https://api.brownbook.net/businesses/reviews/{replyId}
*BusinessesApi* | [**UpdatedBusiness**](docs/BusinessesApi.md#updatedbusiness) | **Post** /businesses/{businessId} | https://api.brownbook.net/businesses/{businessId}
*TokenApi* | [**Token**](docs/TokenApi.md#token) | **Post** /token | https://api.brownbook.net/token/

## Documentation For Models

 - [AdditionalWebsite](docs/AdditionalWebsite.md)
 - [ApiStats](docs/ApiStats.md)
 - [ApiStatsCollection](docs/ApiStatsCollection.md)
 - [Business](docs/Business.md)
 - [Business404NotFound](docs/Business404NotFound.md)
 - [Business500Error](docs/Business500Error.md)
 - [BusinessCreated200](docs/BusinessCreated200.md)
 - [BusinessCreatingError](docs/BusinessCreatingError.md)
 - [BusinessDetails](docs/BusinessDetails.md)
 - [BusinessDetailsWhenUpdate](docs/BusinessDetailsWhenUpdate.md)
 - [BusinessHours](docs/BusinessHours.md)
 - [BusinessMultiple](docs/BusinessMultiple.md)
 - [BusinessSchemaError](docs/BusinessSchemaError.md)
 - [BusinessSchemaErrorIssues](docs/BusinessSchemaErrorIssues.md)
 - [BusinessUpdating](docs/BusinessUpdating.md)
 - [Fields](docs/Fields.md)
 - [FieldsForBusinessMultiple](docs/FieldsForBusinessMultiple.md)
 - [FieldsForUpdate](docs/FieldsForUpdate.md)
 - [Hour](docs/Hour.md)
 - [Image](docs/Image.md)
 - [Interval](docs/Interval.md)
 - [Logo](docs/Logo.md)
 - [ReplyAlreadyCreatedResponse](docs/ReplyAlreadyCreatedResponse.md)
 - [ReplyDeleteResponse](docs/ReplyDeleteResponse.md)
 - [ReplyEditedResponse](docs/ReplyEditedResponse.md)
 - [ReplyEditedResponse400](docs/ReplyEditedResponse400.md)
 - [ReplyEditedResponse405](docs/ReplyEditedResponse405.md)
 - [ReplyReplyIdBody](docs/ReplyReplyIdBody.md)
 - [ReplyReplyIdBody1](docs/ReplyReplyIdBody1.md)
 - [ReplyResponse](docs/ReplyResponse.md)
 - [ReplyResponse400](docs/ReplyResponse400.md)
 - [ReplyResponse401](docs/ReplyResponse401.md)
 - [ReplyResponse404](docs/ReplyResponse404.md)
 - [ReplyResponse404R](docs/ReplyResponse404R.md)
 - [ReviewObject](docs/ReviewObject.md)
 - [ReviewReplyObject](docs/ReviewReplyObject.md)
 - [Reviews200](docs/Reviews200.md)
 - [SpecialOffer](docs/SpecialOffer.md)
 - [Token](docs/Token.md)
 - [TokenExpired](docs/TokenExpired.md)
 - [TokenResponse200](docs/TokenResponse200.md)
 - [TokenResponse400](docs/TokenResponse400.md)
 - [TokenResponse401](docs/TokenResponse401.md)
 - [TokenResponse500](docs/TokenResponse500.md)

## Documentation For Authorization
 Endpoints do not require authorization.


## Author


