# {{classname}}

All URIs are relative to *https://api.brownbook.net/*

Method | HTTP request | Description
------------- | ------------- | -------------
[**DeleteBusinessReply**](BusinessesApi.md#DeleteBusinessReply) | **Delete** /businesses/reviews/reply/{replyId} | deleteBusinessReply
[**GetBusiness**](BusinessesApi.md#GetBusiness) | **Get** /businesses/{businessId} | https://api.brownbook.net/businesses/{businessId}
[**GetBusinessDupe**](BusinessesApi.md#GetBusinessDupe) | **Get** /businesses/dupe/{businessId} | https://api.brownbook.net/businesses/dupe/{businessId}
[**GetBusinesses**](BusinessesApi.md#GetBusinesses) | **Get** /businesses | https://api.brownbook.net/businesses/
[**GetBusinessesReviews**](BusinessesApi.md#GetBusinessesReviews) | **Get** /businesses/reviews | https://api.brownbook.net/businesses/reviews/
[**PostBusinessReply**](BusinessesApi.md#PostBusinessReply) | **Put** /businesses/reviews/reply/{commentId} | https://api.brownbook.net/businesses/reviews/{commentId}
[**PostBusinesses**](BusinessesApi.md#PostBusinesses) | **Post** /businesses | https://api.brownbook.net/businesses/
[**UnclaimBusiness**](BusinessesApi.md#UnclaimBusiness) | **Get** /businesses/unclaim/{businessId} | https://api.brownbook.net/businesses/unclaim/{businessId}
[**UpdateBusinessReply**](BusinessesApi.md#UpdateBusinessReply) | **Post** /businesses/reviews/reply/{replyId} | https://api.brownbook.net/businesses/reviews/{replyId}
[**UpdatedBusiness**](BusinessesApi.md#UpdatedBusiness) | **Post** /businesses/{businessId} | https://api.brownbook.net/businesses/{businessId}

# **DeleteBusinessReply**
> []ReplyDeleteResponse DeleteBusinessReply(ctx, body, replyId, optional)
deleteBusinessReply

Deletes reply on a business comment.

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **body** | [**ReplyReplyIdBody1**](ReplyReplyIdBody1.md)|  | 
  **replyId** | **string**|  | 
 **optional** | ***BusinessesApiDeleteBusinessReplyOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a BusinessesApiDeleteBusinessReplyOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------


 **authorization** | **optional.**|  | [default to Bearer {token}]

### Return type

[**[]ReplyDeleteResponse**](ReplyDeleteResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **GetBusiness**
> BusinessDetails GetBusiness(ctx, contentType, accept, optional)
https://api.brownbook.net/businesses/{businessId}

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **contentType** | **string**|  | 
  **accept** | **string**|  | 
 **optional** | ***BusinessesApiGetBusinessOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a BusinessesApiGetBusinessOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------


 **authorization** | **optional.String**|  | [default to Bearer {token}]

### Return type

[**BusinessDetails**](businessDetails.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **GetBusinessDupe**
> GetBusinessDupe(ctx, businessId, optional)
https://api.brownbook.net/businesses/dupe/{businessId}

Mark a business to be suppressed from listing and optionaly adding a canonical listing id to redirect it to, or unmark it as such.

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **businessId** | **string**|  | 
 **optional** | ***BusinessesApiGetBusinessDupeOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a BusinessesApiGetBusinessDupeOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **authorization** | **optional.String**|  | [default to Bearer {token}]

### Return type

 (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **GetBusinesses**
> []BusinessMultiple GetBusinesses(ctx, country, limit, offset, optional)
https://api.brownbook.net/businesses/

Gets BusinessSearchResult objects.

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **country** | **string**| Specify country for filtering businesses (required) (US,CA,AU) | 
  **limit** | **int32**| Takes specified number of records | 
  **offset** | **int32**| Offset the results from this number | 
 **optional** | ***BusinessesApiGetBusinessesOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a BusinessesApiGetBusinessesOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------



 **authorization** | **optional.String**|  | [default to Bearer {token}]
 **contentType** | **optional.String**|  | 
 **accept** | **optional.String**|  | 

### Return type

[**[]BusinessMultiple**](BusinessMultiple.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **GetBusinessesReviews**
> Reviews200 GetBusinessesReviews(ctx, businessId, contentType, accept, optional)
https://api.brownbook.net/businesses/reviews/

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **businessId** | **int32**| brownbook business Id (required) | 
  **contentType** | **string**|  | 
  **accept** | **string**|  | 
 **optional** | ***BusinessesApiGetBusinessesReviewsOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a BusinessesApiGetBusinessesReviewsOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------



 **authorization** | **optional.String**|  | [default to Bearer {token}]
 **num** | **optional.Int32**| Page number (2 page will make an offset 1000 * 2 &#x3D; 2000, 1 by default) | 
 **limit** | **optional.Int32**| Result limit (1000 by default) | 
 **page** | **optional.Int32**| Page number parameter | 
 **offset** | **optional.Int32**| Offset parameter. If offset is filled and page is empty then page will be as ceil(($offset+$offset) / $num + 1). | 
 **orderBy** | **optional.String**| Order parameter. By default created_at. Can be created_at, id, updated_at, rating | 
 **sortBy** | **optional.String**| Sort parameter. By default ascending (asc). Can have 2 stages - asc or desc | 

### Return type

[**Reviews200**](Reviews200.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **PostBusinessReply**
> []ReplyResponse PostBusinessReply(ctx, commentId, message, businessId, optional)
https://api.brownbook.net/businesses/reviews/{commentId}

Creates reply on a business comment.

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **commentId** | **string**|  | 
  **message** | **string**|  | 
  **businessId** | **int32**| Creates verification if comment reply belongs to business | 
 **optional** | ***BusinessesApiPostBusinessReplyOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a BusinessesApiPostBusinessReplyOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------



 **authorization** | **optional.String**|  | [default to Bearer {token}]

### Return type

[**[]ReplyResponse**](ReplyResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **PostBusinesses**
> BusinessCreated200 PostBusinesses(ctx, body, optional)
https://api.brownbook.net/businesses/

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **body** | [**BusinessDetails**](BusinessDetails.md)| JSON string | 
 **optional** | ***BusinessesApiPostBusinessesOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a BusinessesApiPostBusinessesOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **authorization** | **optional.**|  | [default to Bearer {token}]
 **accept** | **optional.**|  | 
 **contentType** | **optional.**|  | 

### Return type

[**BusinessCreated200**](BusinessCreated200.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UnclaimBusiness**
> UnclaimBusiness(ctx, businessId, optional)
https://api.brownbook.net/businesses/unclaim/{businessId}

Unclaim a business and removed extended content.

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **businessId** | **string**|  | 
 **optional** | ***BusinessesApiUnclaimBusinessOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a BusinessesApiUnclaimBusinessOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------

 **authorization** | **optional.String**|  | [default to Bearer {token}]

### Return type

 (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UpdateBusinessReply**
> []ReplyEditedResponse UpdateBusinessReply(ctx, body, replyId, optional)
https://api.brownbook.net/businesses/reviews/{replyId}

Edits reply on a business comment.

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **body** | [**ReplyReplyIdBody**](ReplyReplyIdBody.md)|  | 
  **replyId** | **string**| Id of reply | 
 **optional** | ***BusinessesApiUpdateBusinessReplyOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a BusinessesApiUpdateBusinessReplyOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------


 **authorization** | **optional.**|  | [default to Bearer {token}]

### Return type

[**[]ReplyEditedResponse**](ReplyEditedResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UpdatedBusiness**
> Business UpdatedBusiness(ctx, body, businessId, optional)
https://api.brownbook.net/businesses/{businessId}

Edit a business

### Required Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **ctx** | **context.Context** | context for authentication, logging, cancellation, deadlines, tracing, etc.
  **body** | [**BusinessDetailsWhenUpdate**](BusinessDetailsWhenUpdate.md)| Business details object | 
  **businessId** | **string**|  | 
 **optional** | ***BusinessesApiUpdatedBusinessOpts** | optional parameters | nil if no parameters

### Optional Parameters
Optional parameters are passed through a pointer to a BusinessesApiUpdatedBusinessOpts struct
Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------


 **authorization** | **optional.**|  | [default to Bearer {token}]

### Return type

[**Business**](Business.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

